/* -*- c++ -*- */
/* 
 * Copyright 2015 Ingo D. Rullhusen <d01c@freeshell.de>.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifndef INCLUDED_RDS_CLOCK_IMPL_H
#define INCLUDED_RDS_CLOCK_IMPL_H

#include <gnuradio/filter/iir_filter.h>

#include <rds/clock.h>

namespace gr {
  namespace rds {

    class RDS_API clock_impl : public clock
    {
     private:

      float samp_rate;
      double d_c_phase;

      filter::kernel::iir_filter<float,float,double,double> *bp_in;
      filter::kernel::iir_filter<float,float,double,double> *pll;
      filter::kernel::iir_filter<gr_complex,gr_complex,double,gr_complexd> *lp_out;

     public:
      clock_impl(float samplerate);
      ~clock_impl();

      // Where all the action really happens
      void forecast (int noutput_items, gr_vector_int &ninput_items_required);

      int general_work(int noutput_items,
		       gr_vector_int &ninput_items,
		       gr_vector_const_void_star &input_items,
		       gr_vector_void_star &output_items);
    };

  } // namespace rds
} // namespace gr

#endif /* INCLUDED_RDS_CLOCK_IMPL_H */
