
#include "crc.h"


#define GPOLY 0x000005b9
#define B11SR 0x00000400
#define CRCMASK 0x000003ff


void crc( unsigned char *rbuff, int size, int pos, U32 *block )
{
   unsigned char b, b11;
   int i;
   U32 sr = 0;

   *block = 0;

   for ( i=0; i<datasize; ++i )
   {
      unsigned char b = rbuff[ (pos+i)%size ];

      *block <<= 1;
      if ( b ) { *block |= 0x00000001; }

      sr <<= 1;
      if ( b != ((sr & B11SR)>0) )
      {
         sr ^= GPOLY;
      }
   }

   *block <<= crcsize;
   *block |= sr & CRCMASK;

}


int decode( unsigned char *rbuff, int size, int pos, U32 OW, U32 *block )
{
   int i, ret;
   U32 mask32, dcrc1, dcrc2, syn;

   crc( rbuff, size, pos, &dcrc1 );

   dcrc2 = 0;
   mask32 = 0x00000200;  // 10. Bit
   for ( i=0; i<crcsize; ++i )
   {
      dcrc2 |= ( rbuff[ (pos+datasize+i)%size ] ? mask32 : 0 );
      mask32 >>= 1;
   }

   syn = ( ( dcrc2 ^ OW ) ^ dcrc1 ) & CRC_MASK;

   *block = dcrc1 ^ crc_syndrome[ syn ];

   return( ( syn ? 1 : 0 ) );
}


int blkno( unsigned char *rbuff, int size, int pos )
{
   int i, ret;
   U32 mask32, dcrc1, dcrc2, syn;

   crc( rbuff, size, pos, &dcrc1 );

   dcrc2 = 0;
   mask32 = 0x00000200;  // 10. Bit
   for ( i=0; i<crcsize; ++i )
   {
      dcrc2 |= ( rbuff[ (pos+datasize+i)%size ] ? mask32 : 0 );
      mask32 >>= 1;
   }

   syn = ( dcrc2 ^ dcrc1 ) & CRC_MASK;

   if ( syn == CRC_OW_A  ) return( 0 );
   if ( syn == CRC_OW_B  ) return( 1 );
   if ( syn == CRC_OW_C  ) return( 2 );
   if ( syn == CRC_OW_CS ) return( 3 );
   if ( syn == CRC_OW_D  ) return( 4 );
   if ( syn == CRC_OW_E  ) return( 5 );

   return(-1);
}
