#ifndef CRC_H
#define CRC_H


typedef unsigned int U32;


#define blocksize 26
#define datasize 16
#define crcsize 10

#define CRC_MASK 0x000003ff

#define CRC_OW_A    0x000000fc
#define CRC_OW_B    0x00000198
#define CRC_OW_C    0x00000168
#define CRC_OW_CS   0x00000350
#define CRC_OW_D    0x000001b4
#define CRC_OW_E    0x00000000


extern U32 crc_syndrome[1024];


#ifdef __cplusplus

extern "C"
void crc( unsigned char *rbuff, int size, int pos,
          U32 *block );

extern "C"
int decode( unsigned char *rbuff, int size, int pos,
            U32 OW, U32 *block );

extern "C"
int blkno( unsigned char *rbuff, int size, int pos );

#else

void crc( unsigned char *rbuff, int size, int pos,
          U32 *block );

int decode( unsigned char *rbuff, int size, int pos,
            U32 OW, U32 *block );

int blkno( unsigned char *rbuff, int size, int pos );

#endif


#endif
