/* -*- c++ -*- */
/* 
 * Copyright 2015 Ingo D. Rullhusen <d01c@freeshell.de>.
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifndef INCLUDED_RDS_DISPLAY_IMPL_H
#define INCLUDED_RDS_DISPLAY_IMPL_H

#include <rds/display.h>
#include "rdswidget.h"

namespace gr {
  namespace rds {

    class RDS_API display_impl : public display
    {
     private:
      int d_argc;
      char *d_argv;
      QWidget *d_parent;
      RDSWidget *d_main_gui;

     public:
      display_impl(QWidget *parent);
      ~display_impl();

      bool check_topology(int ninputs, int noutputs);

      void exec_();
      QWidget*  qwidget();

#ifdef ENABLE_PYTHON
      PyObject* pyqwidget();
#else
      void* pyqwidget();
#endif

// Where all the action really happens
      int work(int noutput_items,
	       gr_vector_const_void_star &input_items,
	       gr_vector_void_star &output_items);
    };

  } // namespace rds
} // namespace gr

#endif /* INCLUDED_RDS_DISPLAY_IMPL_H */

