
#include "rdata.h"

int setup_data( RData *D, U32 blk1, U32 blk2, U32 blk3, U32 blk4 )
{
   unsigned char addr, b[4];
   int i;

   D->PI.ui = blk1 >> 10;

   D->type = ( blk2 & 0x03c00000 ) >> 22;
   D->B0   = ( blk2 & 0x00200000 ) >> 21;
   D->TP   = ( blk2 & 0x00100000 ) >> 20;

   D->PTY  = ( blk2 & 0x000f8000 ) >> 15;

   if ( D->type == 0 )
   {

   D->TA = ( blk2 & 0x00004000 ) >> 14;
   D->MS = ( blk2 & 0x00002000 ) >> 13;

   addr = ( blk2 & 0x00000c00 ) >> 10;
   D->DI[ addr ] = ( blk2 & 0x00001000 ) >> 12;

   b[0] = ( blk4 & 0x03fc0000 ) >> 18;
   b[1] = ( blk4 & 0x0003fc00 ) >> 10;
   for ( i=0; i<2; ++i )
   {
      if ( b[i]!=14 && b[i]!=15 && b[i]!=27 )
      { D->PS[ 2*addr+i ] = b[i]; }
   }

   if ( D->B0 )
   {
   }
   else
   {
      b[0] = ( blk3 & 0x03fc0000 ) >> 18;
      b[1] = ( blk3 & 0x0003fc00 ) >> 10;

      for ( i=0; i<2; ++i )
      {
         if ( b[i] > 224 && b[i] < 250 )
         { D->AF.nomax = b[i] - 224; D->AF.no = 0; D->AF.LFMF = 0; }
         if ( b[i] == 250 )
         { D->AF.LFMF = 1; }
         if ( b[i] > 0 && b[i] < 205 && D->AF.no < D->AF.nomax )
         { D->AF.kHz[D->AF.no] = 100*b[i] + 87500; ++D->AF.no; }
         if ( b[i] > 0 && b[i] < 16 && D->AF.no < D->AF.nomax && D->AF.LFMF )
         { D->AF.kHz[D->AF.no] = 9*b[i] + 144; ++D->AF.no; }
         if ( b[i] > 15 && b[i] < 136 && D->AF.no < D->AF.nomax && D->AF.LFMF )
         { D->AF.kHz[D->AF.no] = 9*b[i] + 387; ++D->AF.no; }         
      }
   }

   }

   if ( D->type == 1 )
   {

      D->PIN.ui = ( blk4 & 0x03fffc00 ) >> 10;

      if ( D->B0 )
      {
      }
      else
      {
         D->LA  = ( blk3 & 0x02000000 ) >> 25;
         D->OPC = ( blk3 & 0x003c0000 ) >> 18;
         D->ECC = ( blk3 & 0x0003fc00 ) >> 10;
      }

   }

   if ( D->type == 2 )
   {
      if ( (( blk2 & 0x00004000 ) >> 14) != D->TextAB )
      {
         for ( i = 0; i < 64; ++i ) { D->RT[i] = ' '; }
         D->TextAB = ( blk2 & 0x00004000 ) >> 14;
      }

      addr = ( blk2 & 0x00003c00 ) >> 10;

      if ( D->B0 )
      {
         b[0] = ( blk4 & 0x03fc0000 ) >> 18;
         b[1] = ( blk4 & 0x0003fc00 ) >> 10;
         for ( i=0; i<2; ++i )
         {
            if ( b[i]!=14 && b[i]!=15 && b[i]!=27 && b[i]!=110 )
            { D->RT[ 2*addr+i ] = b[i]; }
         }
      }
      else
      {
         b[0] = ( blk3 & 0x03fc0000 ) >> 18;
         b[1] = ( blk3 & 0x0003fc00 ) >> 10;
         b[2] = ( blk4 & 0x03fc0000 ) >> 18;
         b[3] = ( blk4 & 0x0003fc00 ) >> 10;
         for ( i=0; i<4; ++i )
         {
            if ( b[i]!=14 && b[i]!=15 && b[i]!=27 )
            { D->RT[ 4*addr+i ] = b[i]; }
         }
      }

   }
   

   if ( D->type == 4 )
   {
      if ( D->B0 )
      {}
      else
      {
         D->timeJD     = ((( blk2 & 0x00000c00 ) >> 10) << 15) + (( blk3 & 0x03fffc00 ) >> 11);
         D->timeHour   = ((( blk3 & 0x00000400 ) >> 10) <<  4) + (( blk4 & 0x03fffc00 ) >> 22);
         D->timeMinute = ( blk4 & 0x003ffc00 ) >> 16;

         D->timeOffset = ( blk4 & 0x00007c00 ) >> 10;
         D->timeOffset *= ( blk4 && 0x00008000 ? -1 : +1 );
      }
   }


   return(0);
}

